function var_mog=subf_mog_update(var_mog,var_uv,Y,par_all,stage)
%% 
Z=var_mog.Z;
num=var_mog.num;
UVt=var_uv.UVt;
UVt2=var_uv.UVt2;
cr=var_uv.cr;
a0=par_all.model.a0;
b0=par_all.model.b0;
alpha0=par_all.model.alpha0;
tol=par_all.mog.tol;
thre=par_all.mog.thre;
noise_idx=par_all.loc.noise;
true_idx=par_all.loc.true;
miss_idx=par_all.loc.miss;
%% 
a=a0+1/2*sum(Z,1);
Y_minus_UVt2=Y.^2-2*Y.*UVt+UVt2;
b=b0+1/2*Y_minus_UVt2(:)'*Z;
tau=a./b;
%% 
if num>1 && cr<tol
    diff_map_temp=repmat(1./tau,num,1);
    diff_map=abs(diff_map_temp-diff_map_temp')./(diff_map_temp+diff_map_temp')+tril(ones(num));
    [diff_min,diff_idx]=min(diff_map(:));
    if diff_min<thre
        [diff_idx1,diff_idx2]=ind2sub([num,num],diff_idx);
        Z(:,diff_idx1)=Z(:,diff_idx1)+Z(:,diff_idx2);Z(:,diff_idx2)=[];
        a(diff_idx1)=a(diff_idx1)+a(diff_idx2)-a0;a(diff_idx2)=[];
        b(diff_idx1)=b(diff_idx1)+b(diff_idx2)-b0;b(diff_idx2)=[];
        tau(diff_idx1)=a(diff_idx1)/b(diff_idx1);tau(diff_idx2)=[];
        num=num-1;
    end
end
%% 
m(1)=size(Y,1);m(2)=size(Y,2);m(3)=numel(Y)/m(1)/m(2);
if num==1
    alpha=ones([m(3) num]);
    Z=ones(prod(m),1);
else
    %
    alpha=alpha0+reshape(sum(reshape(Z,m(1)*m(2),[]),1),[m(3) num]);
    ln_Pi=bsxfun(@plus,psi(0,alpha),-psi(0,sum(alpha,2)));
    %
    ln_tau=psi(0,a)-log(b);
    ln_rho=1/2*(-log(2*pi)+repmat(ln_tau,[prod(m),1])-Y_minus_UVt2(:)*tau+2*kron(ln_Pi,ones(m(1)*m(2),1)));
    Z=exp(bsxfun(@minus,ln_rho,ln_sum_exp_mth(ln_rho,2)));
end
Z(~noise_idx,:)=0;
Pi=alpha./repmat(sum(alpha,2),1,num);
%% 
Z_tau=reshape(Z*tau',size(Y));
Z_tau(miss_idx)=0;
if stage==1
    Z_tau(true_idx)=1e2*max(1,max(abs(Y(:))));
else
    Z_tau(true_idx)=1e10*max(1,max(abs(Y(:))));
end
%% 
var_mog.Z=Z;
var_mog.tau=tau;
var_mog.Pi=Pi;
var_mog.num=num;
var_mog.Z_tau=Z_tau;
end