function [var_uv,var_rank,res]=subf_uv_rank_update(var_uv,var_rank,res,var_mog,var_dim,Y,par_all,stage,iter,dim)
%% 
unfold=par_all.dim.unfold{dim};
fold=par_all.dim.fold{dim};
Z_tau=var_mog.Z_tau;
w=var_dim.w;
xi=var_dim.xi;
xi0=var_dim.xi0;
xi0_zero=var_dim.xi0_zero;
X=var_dim.X;
cr_X_minus_UVt=var_dim.cr_X_minus_UVt;
U=var_uv.U;UtU=var_uv.UtU;
V=var_uv.V;VtV=var_uv.VtV;
UV_gamma=var_uv.UV_gamma;
UVt_old=var_uv.UVt;
cr_old=var_uv.cr;
%data_type=par_all.others.data_type;
detail_show=par_all.others.detail_show;
e0=par_all.model.e0;
f0=par_all.model.f0;
par_rank=par_all.rank;
%% 
Y_unfold=unfold(Y);
X_unfold=unfold(X);
Z_tau_unfold=unfold(Z_tau);
if size(w,1)==1
    xi_plus_Z_tau=xi*w(dim)+Z_tau_unfold;
    xi_X_plus_Z_tau_Y=xi*w(dim)*X_unfold+Z_tau_unfold.*Y_unfold;
else
    w=unfold(repmat(reshape(w(:,dim),1,1,[]),size(Y,1),size(Y,2)));
    xi_plus_Z_tau=xi*w+Z_tau_unfold;
    xi_X_plus_Z_tau_Y=xi*w.*X_unfold+Z_tau_unfold.*Y_unfold;
end
%% 
[m,n]=size(xi_plus_Z_tau);
if m>n
    %
    time_U=tic;
    [U,UtU,U_sigma,U_sigma_diag]=ssubf_uv(V,VtV,xi_plus_Z_tau,xi_X_plus_Z_tau_Y,UV_gamma);
    time_U=toc(time_U);if detail_show;fprintf('tU=%.2e,',time_U);end
    time_V=tic;
    [V,VtV,V_sigma,V_sigma_diag]=ssubf_uv(U,UtU,xi_plus_Z_tau',xi_X_plus_Z_tau_Y',UV_gamma);
    time_V=toc(time_V);if detail_show;fprintf('tV=%.2e;',time_V);end
else
    %
    time_V=tic;
    [V,VtV,V_sigma,V_sigma_diag]=ssubf_uv(U,UtU,xi_plus_Z_tau',xi_X_plus_Z_tau_Y',UV_gamma);
    time_V=toc(time_V);if detail_show;fprintf('tV=%.2e;',time_V);end
    time_U=tic;
    [U,UtU,U_sigma,U_sigma_diag]=ssubf_uv(V,VtV,xi_plus_Z_tau,xi_X_plus_Z_tau_Y,UV_gamma);
    time_U=toc(time_U);if detail_show;fprintf('tU=%.2e,',time_U);end
end
%
e=m+n+2*e0;
f=2*f0+sum(U.*U,1)'+U_sigma_diag+sum(V.*V,1)'+V_sigma_diag;
UV_gamma=e./f;
%% 
rank_curr=numel(UV_gamma);
rank_max=min(size(U,1),size(V,1));
%
[gam,gam_idx]=sort(UV_gamma,'ascend');
gam=gam/min(gam);
%
sv=sv_mth(U*V');
sv(rank_curr+1:end)=0;
%
[sv_inv,sv_cumsum,sv_avg,sv_cumsum_avg,lr_idx]=ssubf_rank_info(sv,par_rank.idx_type);
sv_inv=sv_inv(1:rank_curr);
sv_cumsum=sv_cumsum(1:rank_curr);
drop_index=find(sv_cumsum>1-par_rank.thre,1,'first');%
if isempty(drop_index)
    drop_index=rank_curr;
end
drop_num_max=rank_max-drop_index;%
drop_thre_new=sv_inv(drop_index);%
drop_thre=min(par_rank.thre_min_ratio*sv_inv(end),max([10,var_rank.thre,drop_thre_new]));
if stage==1
    drop_num=min([sum(sv_inv>drop_thre),drop_num_max,ceil(0.1*par_rank.max(dim))]);
    if ~xi0_zero%
        cr_X_minus_UVt=cr_X_minus_UVt(dim);
        if ~(xi0>par_rank.xi0_inf(1) && cr_X_minus_UVt<par_rank.cr_inf(1))
            drop_num=min(drop_num,max(0,rank_curr-ceil(par_rank.drop_num_inf(dim,1)*par_rank.max(dim))));
        elseif ~(xi0>par_rank.xi0_inf(2) && cr_X_minus_UVt<par_rank.cr_inf(2))
            drop_num=min(drop_num,max(0,rank_curr-ceil(par_rank.drop_num_inf(dim,2)*par_rank.max(dim))));
        elseif ~(xi0>par_rank.xi0_inf(3) && cr_X_minus_UVt<par_rank.cr_inf(3))
            drop_num=min(drop_num,max(0,rank_curr-ceil(par_rank.drop_num_inf(dim,3)*par_rank.max(dim))));
        end
    end
    drop_num=min(drop_num,max(0,rank_curr-par_rank.min(dim)));
else
    drop_num=max(0,rank_curr-var_rank.sequence(iter));
end
%
col=[rank_curr;sv_avg;sv_cumsum_avg;lr_idx;drop_thre];
data=[gam sv_inv sv_cumsum];
rank_info=cat_mth(2,col,data);
if drop_num
    rank_idx=true(1,rank_curr);%
    rank_idx(gam_idx(end-drop_num+1:end))=false;
    m=size(U,1);n=size(V,1);
    U=U(:,rank_idx);V=V(:,rank_idx);
    UV_gamma=UV_gamma(rank_idx);
    U_sigma=U_sigma(rank_idx,rank_idx,:);
    V_sigma=V_sigma(rank_idx,rank_idx,:);
    UtU=reshape(UtU,rank_curr,rank_curr,m);%
    UtU=reshape(UtU(rank_idx,rank_idx,:),[],m);%
    VtV=reshape(VtV,rank_curr,rank_curr,n);%
    VtV=reshape(VtV(rank_idx,rank_idx,:),[],n);%
    %
    rank_curr=rank_curr-drop_num;
    sv=sv_mth(U*V');sv(rank_curr+1:end)=0;
    [~,~,sv_avg,sv_cumsum_avg,lr_idx]=ssubf_rank_info(sv,par_rank.idx_type);
end
UVt=fold(U*V');%
UVt2=fold(UtU'*VtV);%
cr=norm(UVt(:)-UVt_old(:),'fro')/max(norm(UVt_old(:),'fro'),eps);
%% 
var_uv.U=U;var_uv.UtU=UtU;var_uv.U_sigma=U_sigma;
var_uv.V=V;var_uv.VtV=VtV;var_uv.V_sigma=V_sigma;
var_uv.UV_gamma=UV_gamma;
var_uv.UVt=UVt;
var_uv.UVt2=UVt2;
var_uv.cr_old=cr_old;
var_uv.cr=cr;
%% 
var_rank.curr=rank_curr;
var_rank.sv_avg=sv_avg;
var_rank.sv_cumsum=sv_cumsum_avg;
var_rank.idx=lr_idx;
var_rank.thre=drop_thre;
if drop_num
    var_rank.stable=0;
else
    var_rank.stable=var_rank.stable+1;
end
%% 
res.rank_iter{iter}=cat_mth(2,res.rank_iter{iter},cat_mth(1,dim,rank_info));
res.rank_dim{dim}=cat_mth(2,res.rank_dim{dim},cat_mth(1,iter,rank_info));
end
%% 
function [U,UtU,U_sigma,U_sigma_diag]=ssubf_uv(V,VtV,xi_plus_Z_tau,xi_X_plus_Z_tau_Y,UV_gamma)
m=size(xi_plus_Z_tau,1);
rank_curr=size(V,2);
U=zeros(m,rank_curr);
UtU=zeros(rank_curr^2,m);
U_sigma_diag=zeros(rank_curr,1);
xi_X_plus_Z_tau_Y_V=xi_X_plus_Z_tau_Y*V;
if size(unique(xi_plus_Z_tau,'rows'),1)==1
    U_sigma=repmat((reshape(VtV*xi_plus_Z_tau(1,:)',rank_curr,rank_curr)+diag(UV_gamma))^(-1),[1 1 m]);
    U=xi_X_plus_Z_tau_Y_V*U_sigma(:,:,1);
    U_sigma_diag=m*diag(U_sigma(:,:,1));
    for i=1:m
        UtU(:,i)=reshape(U_sigma(:,:,i)+U(i,:)'*U(i,:),[],1);
    end
else
    U_sigma=bsxfun(@plus,reshape(VtV*xi_plus_Z_tau',rank_curr,rank_curr,m),diag(UV_gamma));
    for i=1:m
        U_sigma(:,:,i)=U_sigma(:,:,i)^(-1);
        U(i,:)=xi_X_plus_Z_tau_Y_V(i,:)*U_sigma(:,:,i);
        U_sigma_diag=U_sigma_diag+diag(U_sigma(:,:,i));
        UtU(:,i)=reshape(U_sigma(:,:,i)+U(i,:)'*U(i,:),[],1);
    end
end
end