function y=sequence_mth(a,b,n,type)
switch type
    case {'lin','linear'}
        y=linspace(a,b,n);
    case {'log','exp'}
        y=logspace(log10(a),log10(b),n);
    case {'linlog','linexp'}
        c=n(2);n=n(1);
        if a<=b
            c=linspace(1,c,n-1);
        else
            c=linspace(c,1,n-1);
        end
        k=(b/a)^(1/sum(c));
        y=zeros(1,n);
        y(1)=a;
        for j=1:(n-1)
            y(j+1)=y(j)*k^c(j);
        end
    otherwise
        error('Unknown type')
end
if any(~isfinite(y))
    warning('y contains Inf or NaN')
end
end
