function A=struct_show_mth(var,par)
%% 
A1={};
if isfield(par,'scalar') && ~isempty(par.scalar)
    if ~iscell(par.scalar)
        par.scalar={{par.scalar}};
    elseif iscellstr(par.scalar)
        par.scalar={par.scalar};
    end
    n1=numel(par.scalar);
    for i=1:n1
        if ~iscellstr(par.scalar{i})
            error('par.scalar must be a string or a cell-string or a cell-cell-string')
        end
    end
    for i=1:n1
        num_temp=numel(par.scalar{i});
        A1_temp=cell(num_temp*2,1);
        for j=1:num_temp
            A1_temp{2*j-1}=par.scalar{i}{j};
            A1_temp{2*j}=var.(par.scalar{i}{j});
        end
        A1=cat_mth(2,A1,A1_temp);
    end
end
%% 
A2={};
if isfield(par,'vector') && ~isempty(par.vector)
    if ~iscell(par.vector)
        par.vector={par.vector};
    end
    if ~iscellstr(par.vector)
        error('par.vector must be a string or a cell-string')
    end
    num=par_extract_mth(par,'num',Inf);
    input_check_mth(num,'n',{1},1,[],1)%
    n2=numel(par.vector);
    for i=1:n2
        name_temp=par.vector{i};
        var_temp=var.(par.vector{i});
        if ~ismatrix(var_temp)
            error('vectors and matrices only');
        end
        if isempty(var_temp)
            var_temp={[]};
        end
        if ~iscell(var_temp)
            var_temp=num2cell(var_temp);
        end
        row_temp=min(size(var_temp,1),num);
        col_temp=size(var_temp,2);
        top_temp=cell(1,col_temp);
        if col_temp>1
            for j=1:col_temp
                top_temp{j}=[name_temp '_' num2str(j)];
            end
        else
            top_temp{1}=name_temp;
        end
        A2=cat_mth(2,A2,[top_temp;var_temp(1:row_temp,:)]);
    end
    A2=[A2;A2(1,:)];
end
%% 
A=cat_mth(2,A1,A2);
end