function X=tmms_mth(X,U,n)
if nargin<3
    n=1:numel(U);
end
if numel(U)~=numel(n)
    error('U and n have different sizes')
end
ind=n>0;
sizeX=size(X);
if ndims(X)<max(n(:))
    sizeX=[sizeX ones(1,max(n(:))-ndims(X))];
end
sizeX=sizeX(ind);
U=U(ind);
n=n(ind);
r=zeros(size(n));
for i=1:numel(n)
    r(i)=size(U{i},1)/sizeX(i);
end
[~,ind]=sort(r,'ascend');
U=U(ind);n=n(ind);
for i=1:numel(n)
    X=tmm_mth(X,U{i},n(i));
end
end