function [sv_inv,sv_cumsum,sv_avg,sv_cumsum_avg,lr_idx]=ssubf_rank_info(sv,lr_idx_type)
rank_max=numel(sv);
sv=sv(:);
sv=sv/max(max(sv),eps);
sv_inv=1./sv;
sv_cumsum=cumsum(sv)/max(sum(sv),eps);
switch lr_idx_type
    case 'lr_idx'
        sv_avg=sum(sv)/rank_max;
        sv_cumsum_avg=sum(1./sv_cumsum-1)/rank_max;
    case 'gini'
        sv_avg=1/rank_max;
        sv_cumsum_avg=2*sum(1-sv_cumsum)/rank_max;
    otherwise
        error('unknown lr_idx_type')
end
lr_idx=sv_avg+sv_cumsum_avg;
end